LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.all;

entity BF_II_FIFO is
  
  generic (
    Tindex : integer := -1;
    Sindex : integer := -1;
    Data_width : integer := 36;
    Fifo_size  : integer := 0);

  port (
    clk      : in  std_logic;
    ctrl : in std_logic_vector(12 downto 0);
    ctrl_out : out std_logic_vector(12 downto 0);
    Data_in  : in  std_logic_vector(Data_width-1 downto 0);
    Data_out : out std_logic_vector(Data_width -1 downto 0));

end BF_II_FIFO;


architecture rtl of BF_II_FIFO is
  signal tofifo, fromfifo : std_logic_vector(Data_width-1 downto 0);
begin  -- rtl




  U_FIFO : entity work.FIFO
    generic map(
      Fifo_size => Fifo_size)
    port map (
      clk      => clk,
      flush      => ctrl(0),
      Data_in  => tofifo,
      Data_out => fromfifo);


  U_BF_II : entity work.BF_II
    generic map (
      Data_width => Data_width)
    port map (
      T      => ctrl(Tindex+9),
      S      => ctrl(Sindex+1),
      BF2_I1 => fromfifo,
      BF2_I2 => Data_in,
      BF2_O1 => Data_out,
      BF2_O2 => tofifo);


  ctrl_out <= ctrl;
  
  
  

end rtl;
