
LIBRARY ieee;
USE ieee.std_logic_1164.all;
--USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.all;
use IEEE.std_logic_signed.all;

ENTITY Mult_complex IS
  Generic (Data_width: integer := 36);
  
  PORT( 
    --clk                  : IN     std_logic;
    mult_i1              : IN     std_logic_vector (Data_width-1 DOWNTO 0);  --Data input
    mult_i2              : IN     std_logic_vector (24-1 DOWNTO 0);  --Data input
    mult_o               : OUT    std_logic_vector (Data_width-1 DOWNTO 0) --Data Data real 
    );
END Mult_complex;

ARCHITECTURE rtl OF Mult_complex IS
  signal mult_i1re   :     std_logic_vector (Data_width/2-1 downto 0);
  signal mult_i1imag :     std_logic_vector (Data_width/2-1 downto 0);
  signal mult_i2re   :     std_logic_vector (24/2-1 downto 0);
  signal mult_i2imag :     std_logic_vector (24/2-1 downto 0);
  signal mult_ore    :     std_logic_vector (12+18 downto 0);
  signal mult_oimag  :     std_logic_vector (12+18 downto 0);
  
  signal temp_1      :     std_logic_vector (18+12-1 downto 0);
  signal temp_2      :     std_logic_vector (18+12-1 downto 0);
  signal temp_3      :     std_logic_vector (18+12-1 downto 0);
  signal temp_4      :     std_logic_vector (18+12-1 downto 0); 
  
begin
  mult_i1re      <= mult_i1 (Data_width-1 downto Data_width/2);
  mult_i1imag    <= mult_i1 (Data_width/2-1 downto 0);
  mult_i2re      <= mult_i2 (24-1 downto 24/2);
  mult_i2imag    <= mult_i2 (24/2-1 downto 0);
  
  
  
  temp_1 <=  mult_i1re * mult_i2re;
  temp_2 <=  mult_i1re * mult_i2imag;
  temp_3 <=  mult_i1imag * mult_i2re;
  temp_4 <=  mult_i1imag * mult_i2imag; 
  
  mult_ore    <= (temp_1(30-1) & temp_1) - (temp_4(30-1) & temp_4);
  mult_oimag  <= (temp_2(30-1) & temp_2) + (temp_3(30-1) & temp_3);
  mult_o      <= mult_ore(30 downto 24/2+1) & mult_oimag(30 downto 24/2+1);
  
end;
