library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity address_generator is
  generic (
    Comparator_value : std_logic_vector(7 downto 0));
  
  port (
    clk     : in  std_logic;
    ctrl    : in  std_logic_vector(12 downto 0);
    address : out std_logic_vector(7 downto 0));

end address_generator;



architecture rtl of address_generator is

  signal add_en, add_en_reg : std_logic;
  signal addr : std_logic_vector(7 downto 0);

  
begin  -- rtl

  address <= addr;
  
  add_en <= '1' when (ctrl(8 downto 1) = Comparator_value) or (add_en_reg = '1') else '0';

  Foraddr1 : process(clk)
  begin
    if rising_edge(clk) then
      add_en_reg <= add_en;
      if add_en = '1' then
        addr <= addr + 1;
      end if;
      if (ctrl(0) = '1') then
        addr       <= (others => '0');
        add_en_reg <= '0';
      end if;
    end if;
  end process;

  

end rtl;
